/***************************************************************************
 *   Copyright (C) 2006 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CITERATORND_H
#define CITERATORND_H

#include "dtgrid.h"
#include "locatornd.h"

/**
	@author Holger Gerth <holger.gerth@informatik.tu-chemnitz.de>
*/
class CIteratorND{
public:

    CDtGrid         *grid;                  // the DT Grid iterated over
    CIteratorND     *iteratorND;            // N-1 dimensional iterator
    double          value;                  // a value
    indexPair       valueIndexPair;         // an index pair
    int             dimension;              // the dimension of the iterator

    CIteratorND();
    CIteratorND( int dimension, CDtGrid *dtgrid = NULL );
    ~CIteratorND();
    bool increment( CLocatorND *loc );       // the increment method
    void initializeLocator( CLocatorND *loc );

};

#endif
