/***************************************************************************
 *   Copyright (C) 2005 by Holger Gerth   *
 *   holg@auenland   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "color4f.h"

CColor4f::CColor4f()
{
	// set color to non transparent black
	this->fRed = 0.0f;
	this->fGreen = 0.0f;
	this->fBlue = 0.0f;
	this->fAlpha = 1.0f;
}

CColor4f::CColor4f(float red, float green, float blue)
{
	// set color to non transparent given values
	this->fRed = red;
	this->fGreen = green;
	this->fBlue = blue;
	this->fAlpha = 1.0f;
}

CColor4f::CColor4f(float red, float green, float blue, float alpha)
{
	// set color to given values
	this->fRed = red;
	this->fGreen = green;
	this->fBlue = blue;
	this->fAlpha = alpha;
}

CColor4f::~CColor4f()
{
}

float CColor4f::getAlpha() const
{
  return fAlpha;
}


void CColor4f::setAlpha(float theValue)
{
  fAlpha = theValue;
}


float CColor4f::getBlue() const
{
  return fBlue;
}


void CColor4f::setBlue(float theValue)
{
  fBlue = theValue;
}


float CColor4f::getGreen() const
{
  return fGreen;
}


void CColor4f::setGreen(float theValue)
{
  fGreen = theValue;
}


float CColor4f::getRed() const
{
  return fRed;
}


void CColor4f::setRed(float theValue)
{
  fRed = theValue;
}
