/***************************************************************************
 *   Copyright (C) 2006 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "gettimeofday.h"


// int gettimeofday(struct timeval* tv) 
//    {
//       union {
//          long long ns100;
//          FILETIME ft;
//       } now;
// 
//       GetSystemTimeAsFileTime (&now.ft);
//       tv->tv_usec = (long) ((now.ns100 / 10LL) % 1000000LL);
//       tv->tv_sec = (long) ((now.ns100 - 116444736000000000LL) / 10000000LL);
//      return (0);
//    }
#if defined(MSC_VER) || defined(WINDOWS)
int gettimeofday(struct timeval *tv, struct timezone *tz) {

    FILETIME ft;
    LARGE_INTEGER li;
    __int64 t;
    static int tzflag;

    if (tv)
    {
        GetSystemTimeAsFileTime(&ft);
        li.LowPart = ft.dwLowDateTime;
        li.HighPart = ft.dwHighDateTime;
        t = li.QuadPart; /* In 100-nanosecond intervals */
        t -= DELTA_EPOCH_IN_USEC; /* Offset to the Epoch time */
        t /= 10; /* In microseconds */
        tv->tv_sec = (long)(t / 1000000);
        tv->tv_usec = (long)(t % 1000000);
    }

    if (tz)
    {
        if (!tzflag)
        {
        _tzset();
        tzflag++;
        }
        tz->tz_minuteswest = _timezone / 60;
        tz->tz_dsttime = _daylight;
    }
    return 0;
}
#endif
