/***************************************************************************
 *   Copyright (C) 2006 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "locatornd.h"

CLocatorND::CLocatorND()
{

    this->parentLoc = NULL;
    this->loc = NULL;
    this->dimension = 1;

}

CLocatorND::CLocatorND( unsigned int dimension, CDtGrid* grid, CLocatorND *parentLoc )
{
    this->parentLoc = parentLoc;
    this->dimension = dimension;

    if ( dimension > 1 ) {

        loc = new CLocatorND( dimension-1, grid->projND, this );

        this->iValue = 0;
        this->iCoord = 0;

        this->Xn = grid->nCoord.at(0);
    }
    else {

        loc = NULL;

        this->iValue = 0;
        this->iCoord = 0;

        this->Xn = grid->nCoord.at(0);
    }

}

CLocatorND::~CLocatorND()
{
    if (this->loc != NULL) delete this->loc;
}



/*!
    \fn CLocatorND::getCoordinate()
 */
vector<int> CLocatorND::getCoordinate()
{
    vector<int> returnValue;
    vector<int> tmp;

    returnValue.push_back( this->Xn );
    if ( this->loc != NULL ) {
        tmp = this->loc->getCoordinate();
        for ( int i = 0; i < tmp.size(); i++ )
            returnValue.push_back( tmp.at(i) );
    }

    return returnValue;
}
