/***************************************************************************
 *   Copyright (C) 2006 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   Locator used by class CDtGrid                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef STDLOCATORND_H
#define STDLOCATORND_H

#include "includes.h"
#include "dtgrid.h"

using namespace std;

/**
	@author Holger Gerth <holger.gerth@informatik.tu-chemnitz.de>
*/

class CLocatorND {

public:
    unsigned int                dimension;                  // dimension of the locator
    CLocatorND                  *loc;                       // locator of lower dimension
    CLocatorND                  *parentLoc;                 // locator of higher dimension
    unsigned int                iValue;                     // index in the value array to the value of the grid point
    unsigned int                iCoord;                     // index in the nCoord array to the N'th coordinate of the first grid point
    int                         Xn;                         // the N'th coordinate of the grid point

    CLocatorND();
    CLocatorND( unsigned int dimension, CDtGrid* grid, CLocatorND *parentLoc = NULL );

    ~CLocatorND();
    vector<int> getCoordinate();


};

#endif
