/***************************************************************************
 *   Copyright (C) 2004 by Holger Gerth                                    *
 *   holger.gerth@informatik.tu-chemnitz.de                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "vector3d.h"
 
CVector3D::CVector3D() {
 	// Constructor
	this->x = 0;
	this->y = 0;
	this->z = 0;
}

CVector3D::CVector3D(float x, float y, float z) {
 	// Constructor
	this->x = x;
	this->y = y;
	this->z = z;
}

CVector3D::CVector3D(CVertex3D a, CVertex3D b) {
 	// Constructor

	this->x = b.getX() - a.getX();
	this->y = b.getY() - a.getY();
	this->z = b.getZ() - a.getZ();
}

CVector3D::~CVector3D() {
	// Destructor
}

// normalize this vector
void CVector3D::normalize() {

	float len = this->length();

	x = x / len;
	y = y / len;
	z = z / len;

}

// calculate the length of this vector
float CVector3D::length() {

	return sqrt(x*x + y*y + z*z);

}


GLfloat CVector3D::getX() const
{
  return x;
}


void CVector3D::setX(const GLfloat& theValue)
{
  x = theValue;
}


GLfloat CVector3D::getY() const
{
  return y;
}


void CVector3D::setY(const GLfloat& theValue)
{
  y = theValue;
}


GLfloat CVector3D::getZ() const
{
  return z;
}


void CVector3D::setZ(const GLfloat& theValue)
{
  z = theValue;
}
